import zmq
import random
import sys
import time

import sys
import getopt

def usage():
    print(f'usage: {sys.argv[0]} [-p port] [-d datafile]')
    print("\t -p port             Port to publish data on (defalut: 7778.")
    print("\t -d datafile         File with stub data.")
    sys.exit()

port = "7778"
file="poweranalyzer_zmq.dat"
#file="poweranalyzer_4port.dat"
mac_replace_list={}
delay=60
mode=None

try:
    opts, args = getopt.getopt(sys.argv[1:],"p:d:r:m:D:")
    #print("opts is: ",opts)
except getopt.GetoptError:
    print("Error: Error Loading Configuration Details: ")
    usage()

for opt,arg in opts:
    #print("opt is: ",opt)
    if opt == "-p":
        port = arg
    elif opt == "-d":
        file = arg
    elif opt == "-r":
        s=arg.split("|")
        if len(s) == 2:
            mac_replace_list[s[0]]=s[1]
    elif opt == "-m":
        mode=arg
    elif opt == "-D":
        delay = float(arg)
    else:
        usage()




#if len(sys.argv) > 1:
#    port =  sys.argv[1]
#   int(port)

context = zmq.Context()
socket = context.socket(zmq.PUB)
socket.bind("tcp://*:%s" % port)


def get_send_ts(cur_ts):
    cur_time=time.time()
    len_diff = len(str(cur_ts)) - len(str(int(cur_time)))
    sts = str(int(cur_time * pow(10,len_diff)))
    return sts

def get_sleep_delta_time(prev_ts,new_ts):
    prev_len = len(str(prev_ts))
    new_len = len(new_ts)
    len_diff=new_len - prev_len
    # print("len_diff: ",len_diff)
    cur_time=time.time()
    delta_factor = len(str(prev_ts)) - len(str(int(cur_time)))
    # print("delta_factor: ",delta_factor)
 
    if len(str(prev_ts)) == len(new_ts):
        sleep_delta=int(new_ts) - prev_ts
    else:
        # print("Lenghts don't match, need to fix that.")
        new_prev_ts = prev_ts * pow(10,len_diff)
        # print("New PREV TS: ",new_prev_ts)
        sleep_delta=0 
    return sleep_delta/pow(10,delta_factor)

def run_batch_data_loop(data_file,batch_delay=None):
    global socket

    fp = open(file)
    Lines = fp.readlines()
    fp.close()
    if batch_delay == None:
        batch_delay = 60
    while True:
        llen = len(Lines)
        s=Lines[0].split(",")
        ts=int(s[0])
        for i in range(llen):
            l=Lines[i]
            for mac,new_mac in mac_replace_list.items():
                l=l.replace(mac,new_mac)
            sts=get_send_ts(ts)
            # print(f"XXXXXXXXXXXXXXX {ts} vs {sts}")
            # send_ts=int(time.time() * 1000)
            # l=l.replace(str(ts),str(send_ts))
            l=l.replace(str(ts),str(sts))
            # print("Sending: ",l)
            socket.send_string(l.strip())
            if i + 1 < llen:
                s=Lines[i+1].split(",")
                # if len(str(ts)) == len(s[0]):
                #     sleep_delta=int(s[0]) - ts
                # else:
                #     # print("Lenghts don't match, need to fix that.")
                #     sleep_delta=0 
                sleep_delta = get_sleep_delta_time(ts,s[0])
                ts = int(s[0])
        time.sleep(batch_delay)
        #socket.send_str("%d %d" % (topic, messagedata))

def run_stream_data_loop(data_file,batch_delay=None):
    global socket

    print("Running batch..")
    fp = open(file)
    Lines = fp.readlines()
    fp.close()

    #for line in Lines:
    #    print(line.strip())


    while True:
        llen = len(Lines)
        s=Lines[0].split(",")
        ts=int(s[0])
        for i in range(llen):
            l=Lines[i]
            for mac,new_mac in mac_replace_list.items():
                l=l.replace(mac,new_mac)
            # send_ts=int(time.time() * 1000)
            # l=l.replace(str(ts),str(send_ts))
            sts=get_send_ts(ts)
            # print(f"XXXXXXXXXXXXXXX {ts} vs {sts}")
            l=l.replace(str(ts),str(sts))
            # print("Sending: ",l)
            socket.send_string(l.strip())
            if i + 1 < llen:
                s=Lines[i+1].split(",")
                # if len(str(ts)) == len(s[0]):
                #    sleep_delta=int(s[0]) - ts
                # else:
                #    print("Lenghts don't match, need to fix that.")
                #    sleep_delta=0 
                sleep_delta = get_sleep_delta_time(ts,s[0])
                #sleep_delta=int(s[0]) - ts
                ts = int(s[0])
            # print("sleep delta: ",sleep_delta)
            #time.sleep(sleep_delta/1000)
            time.sleep(sleep_delta)
        #socket.send_str("%d %d" % (topic, messagedata))


print("mode: ",mode)

if mode == 'batch':
    run_batch_data_loop(file)
else:
    run_stream_data_loop(file)

